//+------------------------------------------------------------------+
//|                                                    CCoinTest.mqh |
//|                                                          Dubovik |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Dubovik"
#property link      ""
#property version   "1.00"
#property strict

#include <CLabouchere.mqh>




//      
class CCoinTest
{
	private:
	protected:
		//  
		//   
		int p_iRepeatsCount;
		//   
		int p_iStartBalance;
		//  
		int p_iTake;
		//  ,   ""
		int p_iPocketPercent;
		//   .  p_bFiftyFifty = true,  p_dSuccessPercent .
		double p_dSuccessPercent;
		//  true -   
		bool p_bFiftyFifty;
		//     -          
		string p_sFileName;
		//  true - ,     
		bool p_bFixedLot;

		//  
		//   
		double p_dBalance;
		//  
		double p_dPocket;
		//   
		int p_iDeals;

		//   CLabouchere -      
		CLabouchere p_Lab;
	public:
		void CCoinTest();
		void ~CCoinTest();

		//   -  
		int GetRepeatsCount() {return p_iRepeatsCount;};
		void SetRepeatsCount(int a_iNew) {p_iRepeatsCount = a_iNew;};

		int GetStartBalance() {return p_iStartBalance;};
		void SetStartBalance(int a_iNew) {p_iStartBalance = a_iNew;};

		int GetTake() {return p_iTake;};
		void SetTake(int a_iNew) {p_iTake = a_iNew;};

		int GetPocketPercent() {return p_iPocketPercent;};
		void SetPocketPercent(int a_iNew) {p_iPocketPercent = a_iNew;};

		double GetSuccessPercent() {return p_dSuccessPercent;};
		void SetSuccessPercent(double a_iNew) {p_dSuccessPercent = a_iNew;};

		bool GetFiftyFifty() {return p_bFiftyFifty;};
		void SetFiftyFifty(bool a_bNew) {p_bFiftyFifty = a_bNew;};

		string GetFileName() {return p_sFileName;};
		void SetFileName(string a_sNew) {p_sFileName = a_sNew;};

		bool GetFixedLot() {return p_bFixedLot;};
		void SetFixedLot(bool a_bNew) {p_bFixedLot = a_bNew;};

		//     
		double GetBalance() {return p_dBalance;};
		double GetPocket() {return p_dPocket;};
		int GetDeals() {return p_iDeals;};

		//     ""      .
		//       .
		//        .
		void Go();
};




void CCoinTest::CCoinTest()
{
	p_iRepeatsCount = 0;
	p_iStartBalance = 0;
	p_iTake = 0;
	p_iPocketPercent = 0;
	p_dSuccessPercent = 0;
	p_bFiftyFifty = false;
	p_sFileName = "";
	p_bFixedLot = false;

	p_dBalance = 0;
	p_dPocket = 0;
	p_iDeals = 0;

	p_Lab.SetStartLot(1);
}




void CCoinTest::~CCoinTest()
{
}




void CCoinTest::Go()
{
	//   
	p_dBalance = p_iStartBalance;
	p_dPocket = 0;
	p_iDeals = 0;

	//   
	p_Lab.Init();

	// ,         -  ,     ""
	double dLastGoodBalance = p_iStartBalance;

	// ,     
	int iSuccessLimit = (int) MathRound(32768 * (100 - p_dSuccessPercent) / 100) - 1;

	int iFile = 0;
		if ( p_sFileName != "" )
			iFile = FileOpen(p_sFileName, FILE_WRITE | FILE_CSV, "\t");

		if ( (iFile != INVALID_HANDLE) || (p_sFileName == "") )
		{
				if (p_sFileName != "")
					FileWrite(iFile, " /", " ", " , $", " ", " ", " ", "     ");

			//  
			double dLot;
			// - ,   
			double dPocketAddition;
			//    $
			double dDeal = 0;
			//  " "
			bool bCoin;
			//  .    p_bFiftyFifty = true   
			//       - 
			int iBitNumber = 0;
			int iRand = MathRand();
				for (int i = 0; (i < p_iRepeatsCount) && (p_dBalance > dDeal); i++)
				{
					//       
					p_iDeals = i;

						//   
						if (p_bFixedLot)
							dLot = 1;
						else
							dLot = p_Lab.GetCurrentLot();

					//     $
					dDeal = p_iTake * dLot;

						if (p_dBalance > dDeal)
						{
								//  
								if (p_bFiftyFifty)
								{
										//   -          
										if (iBitNumber >= 15)
										{
											iRand = MathRand();
											iBitNumber = 0;
										}
			
									bCoin = (iRand >> iBitNumber) & 1;
									iBitNumber++;
								}
								else
								{
									iRand = MathRand();
									bCoin = iRand > iSuccessLimit;
								}
		
								//     
								if (bCoin)
									p_dBalance += dDeal;
								else
									p_dBalance -= dDeal;
		
							//    
							p_Lab.SetResult(bCoin);
		
								//      -     ""
								if (p_dBalance > dLastGoodBalance)
								{
									dPocketAddition = (p_dBalance - dLastGoodBalance) * p_iPocketPercent / 100;
									p_dBalance -= dPocketAddition;
									p_dPocket += dPocketAddition;
									dLastGoodBalance = p_dBalance;
								}
		
								//   
								if ( p_sFileName != "" )
									FileWrite(iFile, i, dLot, dDeal, bCoin, DoubleToString(p_dBalance, 2), DoubleToString(p_dPocket, 2), DoubleToString(p_dBalance + p_dPocket, 2));
						}
				}

				if ( iFile != INVALID_HANDLE )
					FileClose(iFile);
		}
		else
			Print("    ", p_sFileName, "  ");
}
