//+------------------------------------------------------------------+
//|                                                  CLabouchere.mqh |
//|                                                          Dubovik |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Dubovik"
#property link      ""
#property version   "1.00"
#property strict




//  - .
//  / = 1/1.
class CLabouchere
{
	private:
	protected:
		//  .   - 0.1.
		double p_dStartLot;

		// ,      
		double p_dLotsString[];
	public:
		void CLabouchere();
		void ~CLabouchere();

		double GetStartLot() {return p_dStartLot;};
		void SetStartLot(double a_dStartLot) {p_dStartLot = a_dStartLot;};

		//  ,    
		double GetCurrentLot();

		//     -  (true)   (false)
		void SetResult(bool a_bResult);

		//    ,   
		void Init() {ArrayResize(p_dLotsString, 0);};
};




CLabouchere::CLabouchere()
{
	p_dStartLot = 0.1;
}




CLabouchere::~CLabouchere()
{
}




double CLabouchere::GetCurrentLot()
{
	double dResult;

		//     ...
		if (ArraySize(p_dLotsString) == 0)
			// ...     = 
			dResult = p_dStartLot;
		else
		{
				//      ...
				if (ArraySize(p_dLotsString) == 1)
					// ...      +  
					dResult = p_dLotsString[0] + p_dStartLot;
				else
					// ...    =    .
					dResult = p_dLotsString[0] + p_dLotsString[ArraySize(p_dLotsString) - 1];
		}

	return dResult;
}




void CLabouchere::SetResult(bool a_bResult)
{
		//   ...
		if (a_bResult)
		{
				//      2 ...
				if (ArraySize(p_dLotsString) >= 2)
				{
					int k = 0;
						//    
						for (int i = 1; i < ArraySize(p_dLotsString) - 1; i++)
						{
							p_dLotsString[k] = p_dLotsString[i];
							k++;
						}
				}

			ArrayResize(p_dLotsString, MathMax(ArraySize(p_dLotsString) - 2, 0));
		}
		else
		{
			// ... 
			double dLot = GetCurrentLot();
			//     
			ArrayResize(p_dLotsString, ArraySize(p_dLotsString) + 1, 100);
			//      
			p_dLotsString[ArraySize(p_dLotsString) - 1] = dLot;
	}
}
